(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["ReactRecollect"] = factory(require("react"));
	else
		root["ReactRecollect"] = factory(root["react"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_react__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./node_modules/hoist-non-react-statics/dist/hoist-non-react-statics.cjs.js":
/*!**********************************************************************************!*\
  !*** ./node_modules/hoist-non-react-statics/dist/hoist-non-react-statics.cjs.js ***!
  \**********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var reactIs = __webpack_require__(/*! react-is */ "./node_modules/react-is/index.js");
/**
 * Copyright 2015, Yahoo! Inc.
 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
 */
var REACT_STATICS = {
    childContextTypes: true,
    contextType: true,
    contextTypes: true,
    defaultProps: true,
    displayName: true,
    getDefaultProps: true,
    getDerivedStateFromError: true,
    getDerivedStateFromProps: true,
    mixins: true,
    propTypes: true,
    type: true
};
var KNOWN_STATICS = {
    name: true,
    length: true,
    prototype: true,
    caller: true,
    callee: true,
    arguments: true,
    arity: true
};
var FORWARD_REF_STATICS = {
    '$$typeof': true,
    render: true,
    defaultProps: true,
    displayName: true,
    propTypes: true
};
var MEMO_STATICS = {
    '$$typeof': true,
    compare: true,
    defaultProps: true,
    displayName: true,
    propTypes: true,
    type: true
};
var TYPE_STATICS = {};
TYPE_STATICS[reactIs.ForwardRef] = FORWARD_REF_STATICS;
TYPE_STATICS[reactIs.Memo] = MEMO_STATICS;
function getStatics(component) {
    // React v16.11 and below
    if (reactIs.isMemo(component)) {
        return MEMO_STATICS;
    } // React v16.12 and above
    return TYPE_STATICS[component['$$typeof']] || REACT_STATICS;
}
var defineProperty = Object.defineProperty;
var getOwnPropertyNames = Object.getOwnPropertyNames;
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
var getPrototypeOf = Object.getPrototypeOf;
var objectPrototype = Object.prototype;
function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
    if (typeof sourceComponent !== 'string') {
        // don't hoist over string (html) components
        if (objectPrototype) {
            var inheritedComponent = getPrototypeOf(sourceComponent);
            if (inheritedComponent && inheritedComponent !== objectPrototype) {
                hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
            }
        }
        var keys = getOwnPropertyNames(sourceComponent);
        if (getOwnPropertySymbols) {
            keys = keys.concat(getOwnPropertySymbols(sourceComponent));
        }
        var targetStatics = getStatics(targetComponent);
        var sourceStatics = getStatics(sourceComponent);
        for (var i = 0; i < keys.length; ++i) {
            var key = keys[i];
            if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
                var descriptor = getOwnPropertyDescriptor(sourceComponent, key);
                try {
                    // Avoid failures from read-only properties
                    defineProperty(targetComponent, key, descriptor);
                }
                catch (e) { }
            }
        }
    }
    return targetComponent;
}
module.exports = hoistNonReactStatics;


/***/ }),

/***/ "./node_modules/react-is/cjs/react-is.development.js":
/*!***********************************************************!*\
  !*** ./node_modules/react-is/cjs/react-is.development.js ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/** @license React v16.13.1
 * react-is.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

if (true) {
    (function () {
        'use strict';
        // The Symbol used to tag the ReactElement-like types. If there is no native Symbol
        // nor polyfill, then a plain number is used for performance.
        var hasSymbol = typeof Symbol === 'function' && Symbol.for;
        var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
        var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
        var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
        var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
        var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
        var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
        var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
        // (unstable) APIs that have been removed. Can we remove the symbols?
        var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
        var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
        var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
        var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
        var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
        var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
        var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
        var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
        var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
        var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
        var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;
        function isValidElementType(type) {
            return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
                type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
        }
        function typeOf(object) {
            if (typeof object === 'object' && object !== null) {
                var $$typeof = object.$$typeof;
                switch ($$typeof) {
                    case REACT_ELEMENT_TYPE:
                        var type = object.type;
                        switch (type) {
                            case REACT_ASYNC_MODE_TYPE:
                            case REACT_CONCURRENT_MODE_TYPE:
                            case REACT_FRAGMENT_TYPE:
                            case REACT_PROFILER_TYPE:
                            case REACT_STRICT_MODE_TYPE:
                            case REACT_SUSPENSE_TYPE:
                                return type;
                            default:
                                var $$typeofType = type && type.$$typeof;
                                switch ($$typeofType) {
                                    case REACT_CONTEXT_TYPE:
                                    case REACT_FORWARD_REF_TYPE:
                                    case REACT_LAZY_TYPE:
                                    case REACT_MEMO_TYPE:
                                    case REACT_PROVIDER_TYPE:
                                        return $$typeofType;
                                    default:
                                        return $$typeof;
                                }
                        }
                    case REACT_PORTAL_TYPE:
                        return $$typeof;
                }
            }
            return undefined;
        } // AsyncMode is deprecated along with isAsyncMode
        var AsyncMode = REACT_ASYNC_MODE_TYPE;
        var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
        var ContextConsumer = REACT_CONTEXT_TYPE;
        var ContextProvider = REACT_PROVIDER_TYPE;
        var Element = REACT_ELEMENT_TYPE;
        var ForwardRef = REACT_FORWARD_REF_TYPE;
        var Fragment = REACT_FRAGMENT_TYPE;
        var Lazy = REACT_LAZY_TYPE;
        var Memo = REACT_MEMO_TYPE;
        var Portal = REACT_PORTAL_TYPE;
        var Profiler = REACT_PROFILER_TYPE;
        var StrictMode = REACT_STRICT_MODE_TYPE;
        var Suspense = REACT_SUSPENSE_TYPE;
        var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated
        function isAsyncMode(object) {
            {
                if (!hasWarnedAboutDeprecatedIsAsyncMode) {
                    hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint
                    console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
                }
            }
            return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
        }
        function isConcurrentMode(object) {
            return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
        }
        function isContextConsumer(object) {
            return typeOf(object) === REACT_CONTEXT_TYPE;
        }
        function isContextProvider(object) {
            return typeOf(object) === REACT_PROVIDER_TYPE;
        }
        function isElement(object) {
            return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
        }
        function isForwardRef(object) {
            return typeOf(object) === REACT_FORWARD_REF_TYPE;
        }
        function isFragment(object) {
            return typeOf(object) === REACT_FRAGMENT_TYPE;
        }
        function isLazy(object) {
            return typeOf(object) === REACT_LAZY_TYPE;
        }
        function isMemo(object) {
            return typeOf(object) === REACT_MEMO_TYPE;
        }
        function isPortal(object) {
            return typeOf(object) === REACT_PORTAL_TYPE;
        }
        function isProfiler(object) {
            return typeOf(object) === REACT_PROFILER_TYPE;
        }
        function isStrictMode(object) {
            return typeOf(object) === REACT_STRICT_MODE_TYPE;
        }
        function isSuspense(object) {
            return typeOf(object) === REACT_SUSPENSE_TYPE;
        }
        exports.AsyncMode = AsyncMode;
        exports.ConcurrentMode = ConcurrentMode;
        exports.ContextConsumer = ContextConsumer;
        exports.ContextProvider = ContextProvider;
        exports.Element = Element;
        exports.ForwardRef = ForwardRef;
        exports.Fragment = Fragment;
        exports.Lazy = Lazy;
        exports.Memo = Memo;
        exports.Portal = Portal;
        exports.Profiler = Profiler;
        exports.StrictMode = StrictMode;
        exports.Suspense = Suspense;
        exports.isAsyncMode = isAsyncMode;
        exports.isConcurrentMode = isConcurrentMode;
        exports.isContextConsumer = isContextConsumer;
        exports.isContextProvider = isContextProvider;
        exports.isElement = isElement;
        exports.isForwardRef = isForwardRef;
        exports.isFragment = isFragment;
        exports.isLazy = isLazy;
        exports.isMemo = isMemo;
        exports.isPortal = isPortal;
        exports.isProfiler = isProfiler;
        exports.isStrictMode = isStrictMode;
        exports.isSuspense = isSuspense;
        exports.isValidElementType = isValidElementType;
        exports.typeOf = typeOf;
    })();
}


/***/ }),

/***/ "./node_modules/react-is/index.js":
/*!****************************************!*\
  !*** ./node_modules/react-is/index.js ***!
  \****************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

if (false) {}
else {
    module.exports = __webpack_require__(/*! ./cjs/react-is.development.js */ "./node_modules/react-is/cjs/react-is.development.js");
}


/***/ }),

/***/ "./src/collect.tsx":
/*!*************************!*\
  !*** ./src/collect.tsx ***!
  \*************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var hoist_non_react_statics__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! hoist-non-react-statics */ "./node_modules/hoist-non-react-statics/dist/hoist-non-react-statics.cjs.js");
/* harmony import */ var hoist_non_react_statics__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(hoist_non_react_statics__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _updateManager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./updateManager */ "./src/updateManager.ts");
/* harmony import */ var _proxyManager__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./proxyManager */ "./src/proxyManager.ts");
/* harmony import */ var _shared_paths__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./shared/paths */ "./src/shared/paths.ts");
/* harmony import */ var _shared_state__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./shared/state */ "./src/shared/state.ts");
/* harmony import */ var _shared_debug__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./shared/debug */ "./src/shared/debug.ts");
/* harmony import */ var _shared_utils__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./shared/utils */ "./src/shared/utils.ts");








// As we render down into a tree of collected components, we will start/stop
// recording
const componentStack = [];
const startRecordingGetsForComponent = (component) => {
    if (!_shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].isInBrowser)
        return;
    Object(_shared_debug__WEBPACK_IMPORTED_MODULE_6__["debug"])(() => {
        console.groupCollapsed(`RENDER: <${component._name}>`);
    });
    _shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].currentComponent = component;
    componentStack.push(_shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].currentComponent);
};
const stopRecordingGetsForComponent = () => {
    if (!_shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].isInBrowser)
        return;
    Object(_shared_debug__WEBPACK_IMPORTED_MODULE_6__["debug"])(() => {
        console.groupEnd();
    });
    componentStack.pop();
    _shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].currentComponent = componentStack[componentStack.length - 1] || null;
};
/**
 * This shallow clones the store to pass as state to the collected
 * component.
 */
const getStoreClone = () => Object(_shared_utils__WEBPACK_IMPORTED_MODULE_7__["whileMuted"])(() => {
    // We'll shallow clone the store so React knows it's new
    const shallowClone = Object.assign({}, _shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].store);
    // ... but redirect all reads to the real store
    _shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].nextVersionMap.set(shallowClone, _shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].store);
    return _proxyManager__WEBPACK_IMPORTED_MODULE_3__["createShallow"](shallowClone);
});
const collect = (ComponentToWrap) => {
    const componentName = ComponentToWrap.displayName || ComponentToWrap.name || 'NamelessComponent';
    // This ensures that checking prop types doesn't record 'gets' for the
    // component. It's a no-op in prod so not a performance concern.
    if (true) {
        if ('propTypes' in ComponentToWrap) {
            const handler = {
                get(target, prop, receiver) {
                    const checkerFunc = Reflect.get(target, prop, receiver);
                    return new Proxy(checkerFunc, {
                        apply(...args) {
                            return Object(_shared_utils__WEBPACK_IMPORTED_MODULE_7__["whileMuted"])(() => Reflect.apply(...args));
                        },
                    });
                },
            };
            // eslint-disable-next-line no-param-reassign
            ComponentToWrap.propTypes = new Proxy(ComponentToWrap.propTypes, handler);
        }
    }
    class WrappedComponent extends react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent {
        constructor() {
            super(...arguments);
            this.state = {
                // This might be called by React when a parent component has updated with a new store,
                // we want this component (if it's a child) to have that next store as well.
                store: getStoreClone(),
            };
            // TODO (davidg) 2020-02-28: use private #isMounted, waiting on
            //  https://github.com/prettier/prettier/issues/7263
            this._isMounted = false;
            this._isMounting = true;
            // <React.StrictMode> will trigger multiple renders,
            // we must disregard these
            this._isRendering = false;
            this._name = componentName;
        }
        componentDidMount() {
            this._isMounted = true;
            this._isMounting = false;
            // A user shouldn't pass data from the store into a collected component.
            // See the issue linked in the error for details.
            if (this.props) {
                const recollectStoreProps = [];
                // Note this is only a shallow check.
                Object.entries(this.props).forEach(([propName, propValue]) => {
                    // If this prop has a 'path', we know it's from the Recollect store
                    // This is not good!
                    if (_shared_paths__WEBPACK_IMPORTED_MODULE_4__["has"](propValue))
                        recollectStoreProps.push(propName);
                });
                // We'll just report the first match to keep the message simple
                if (recollectStoreProps.length) {
                    console.error(`You are passing part of the Recollect store from one collected component to another, which can cause unpredictable behaviour.\n Either remove the collect() wrapper from <${this._name}/>, or remove the "${recollectStoreProps[0]}" prop.\n More info: https://git.io/JvMOj`);
                }
            }
            // Stop recording. For first render()
            stopRecordingGetsForComponent();
            this._isRendering = false;
        }
        componentDidUpdate() {
            // Stop recording. For not-first render()
            stopRecordingGetsForComponent();
            this._isRendering = false;
        }
        componentWillUnmount() {
            _updateManager__WEBPACK_IMPORTED_MODULE_2__["removeListenersForComponent"](this);
            this._isMounted = false;
        }
        update() {
            // 1. If the component has already unmounted, don't try and set the state
            // 2. The component might not have mounted YET, but is in the middle of its first
            //    render cycle.
            //    For example, if a user sets store.loading to true in App.componentDidMount
            if (this._isMounted || this._isMounting) {
                this.setState({ store: getStoreClone() });
            }
        }
        render() {
            if (!this._isRendering) {
                startRecordingGetsForComponent(this);
                this._isRendering = true;
            }
            const props = Object.assign(Object.assign({}, this.props), { store: this.state.store });
            return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(ComponentToWrap, Object.assign({}, props));
        }
    }
    WrappedComponent.displayName = `Collected(${componentName})`;
    // @ts-ignore - I can't work this out
    return hoist_non_react_statics__WEBPACK_IMPORTED_MODULE_1___default()(WrappedComponent, ComponentToWrap);
};
/* harmony default export */ __webpack_exports__["default"] = (collect);


/***/ }),

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! exports provided: collect, afterChange, initStore, batch, useProps, store, internals */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "store", function() { return store; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "internals", function() { return internals; });
/* harmony import */ var _shared_debug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./shared/debug */ "./src/shared/debug.ts");
/* harmony import */ var _shared_state__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./shared/state */ "./src/shared/state.ts");
/* harmony import */ var _collect__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./collect */ "./src/collect.tsx");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "collect", function() { return _collect__WEBPACK_IMPORTED_MODULE_2__["default"]; });

/* harmony import */ var _shared_pubSub__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./shared/pubSub */ "./src/shared/pubSub.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "afterChange", function() { return _shared_pubSub__WEBPACK_IMPORTED_MODULE_3__["afterChange"]; });

/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./store */ "./src/store.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "initStore", function() { return _store__WEBPACK_IMPORTED_MODULE_4__["initStore"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "batch", function() { return _store__WEBPACK_IMPORTED_MODULE_4__["batch"]; });

/* harmony import */ var _shared_utils__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./shared/utils */ "./src/shared/utils.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "useProps", function() { return _shared_utils__WEBPACK_IMPORTED_MODULE_5__["useProps"]; });







const { store } = _shared_state__WEBPACK_IMPORTED_MODULE_1__["default"];
// `internals` is not part of the Recollect API. It is used by tests.
const internals = _shared_state__WEBPACK_IMPORTED_MODULE_1__["default"];
if (typeof window !== 'undefined') {
    if ('Proxy' in window) {
        window.__RR__ = {
            debugOn: _shared_debug__WEBPACK_IMPORTED_MODULE_0__["debugOn"],
            debugOff: _shared_debug__WEBPACK_IMPORTED_MODULE_0__["debugOff"],
            internals: _shared_state__WEBPACK_IMPORTED_MODULE_1__["default"],
        };
    }
    else {
        console.warn("This browser doesn't support the Proxy object, which react-recollect needs. See https://caniuse.com/#search=proxy to find out which browsers do support it");
    }
}


/***/ }),

/***/ "./src/proxyManager.ts":
/*!*****************************!*\
  !*** ./src/proxyManager.ts ***!
  \*****************************/
/*! exports provided: getHandlerForObject, createShallow */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getHandlerForObject", function() { return getHandlerForObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createShallow", function() { return createShallow; });
/* harmony import */ var _shared_pubSub__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./shared/pubSub */ "./src/shared/pubSub.ts");
/* harmony import */ var _shared_debug__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./shared/debug */ "./src/shared/debug.ts");
/* harmony import */ var _shared_state__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./shared/state */ "./src/shared/state.ts");
/* harmony import */ var _shared_utils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./shared/utils */ "./src/shared/utils.ts");
/* harmony import */ var _shared_paths__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./shared/paths */ "./src/shared/paths.ts");
/* harmony import */ var _shared_constants__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./shared/constants */ "./src/shared/constants.ts");






/**
 * Add a new listener to be notified when a particular value in the store changes
 * To be used when a component reads from a property.
 */
const addListener = (propPath) => {
    if (!_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].currentComponent)
        return;
    // We use a string instead of an array because it's much easier to match
    const pathString = _shared_paths__WEBPACK_IMPORTED_MODULE_4__["makeInternalString"](propPath);
    const components = _shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].listeners.get(pathString) || new Set();
    components.add(_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].currentComponent);
    _shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].listeners.set(pathString, components);
};
/**
 * These are the proxy handlers. Notes:
 * * We have different handlers (different traps) for object/array and
 *    map/set.
 * * When the proxy is muted, use Reflect[trap] and bypass any logic. The
 *    exception is Map/Set methods, where we must bind `this` first
 * * `ORIGINAL` lets us unwrap a proxied object
 * * We redirect to the 'next version' of a target if it has been changed
 */
const getHandlerForObject = (targetObject) => {
    if (_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isMap"](targetObject) || _shared_utils__WEBPACK_IMPORTED_MODULE_3__["isSet"](targetObject)) {
        // Map() and Set() get a special handler, because reads and writes all
        // happen in the get() trap (different to the get() method of the map/set!)
        return {
            get(target, prop) {
                if (prop === _shared_constants__WEBPACK_IMPORTED_MODULE_5__["ORIGINAL"])
                    return target;
                let result = Reflect.get(target, prop);
                // The innards of Map and Set require this binding
                if (_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isFunction"](result))
                    result = result.bind(target);
                // Bail early for some things. Unlike objects/arrays, we will
                // continue on even if !state.currentComponent
                if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].proxyIsMuted || _shared_utils__WEBPACK_IMPORTED_MODULE_3__["isInternal"](prop)) {
                    return result;
                }
                const nextVersion = _shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].nextVersionMap.get(target);
                if (nextVersion)
                    return Reflect.get(nextVersion, prop);
                // Adding to a Map
                if (prop === "set" /* Set */) {
                    const handler = {
                        apply(func, applyTarget, [key, value]) {
                            if (applyTarget.get(key) === value)
                                return true; // No change, no need to carry on
                            return _shared_pubSub__WEBPACK_IMPORTED_MODULE_0__["dispatchUpdateInNextStore"]({
                                target: applyTarget,
                                prop: key,
                                value,
                                updater: (finalTarget, newProxiedValue) => {
                                    Object(_shared_debug__WEBPACK_IMPORTED_MODULE_1__["logSet"])(target, prop, newProxiedValue);
                                    // We call the map.set() now, but on the item in the
                                    // store, and with the new args
                                    return Reflect.apply(finalTarget[prop], finalTarget, [
                                        key,
                                        newProxiedValue,
                                    ]);
                                },
                            });
                        },
                    };
                    return new Proxy(result, handler);
                }
                // Adding to a Set
                if (prop === "add" /* Add */) {
                    const handler = {
                        apply(func, applyTarget, [value]) {
                            if (applyTarget.has(value))
                                return true; // Would be a no op
                            return _shared_pubSub__WEBPACK_IMPORTED_MODULE_0__["dispatchUpdateInNextStore"]({
                                target: applyTarget,
                                notifyTarget: true,
                                value,
                                updater: (finalTarget, newProxiedValue) => {
                                    Object(_shared_debug__WEBPACK_IMPORTED_MODULE_1__["logSet"])(target, prop, newProxiedValue);
                                    return Reflect.apply(finalTarget[prop], finalTarget, [
                                        newProxiedValue,
                                    ]);
                                },
                            });
                        },
                    };
                    return new Proxy(result, handler);
                }
                // On either a Set or Map
                if (prop === "clear" /* Clear */ || prop === "delete" /* Delete */) {
                    const handler = {
                        apply(func, applyTarget, [key]) {
                            if (!applyTarget.size ||
                                (prop === "delete" /* Delete */ && !applyTarget.has(key))) {
                                return false; // false indicates no change
                            }
                            return _shared_pubSub__WEBPACK_IMPORTED_MODULE_0__["dispatchUpdateInNextStore"]({
                                target: applyTarget,
                                notifyTarget: true,
                                updater: (finalTarget) => {
                                    Object(_shared_debug__WEBPACK_IMPORTED_MODULE_1__["logSet"])(target, prop);
                                    return Reflect.apply(finalTarget[prop], finalTarget, [key]);
                                },
                            });
                        },
                    };
                    return new Proxy(result, handler);
                }
                // Now that we've handled any modifying methods, we can
                // just return the result if we're not in the render cycle.
                if (!_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].currentComponent)
                    return result;
                // If we're reading a particular value, we'll want a listener for that
                // We don't listen on `.has` because any change that would result in
                // `.has` returning a different value would update the target
                if (_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isMap"](target) && prop === "get" /* Get */) {
                    const handler = {
                        apply(func, applyTarget, args) {
                            addListener(_shared_paths__WEBPACK_IMPORTED_MODULE_4__["extend"](target, args[0]));
                            return Reflect.apply(func, applyTarget, args);
                        },
                    };
                    return new Proxy(result, handler);
                }
                // For all other read operations, just return
                return result;
            },
        };
    }
    return {
        get(target, prop) {
            // This allows getting the un-proxied version of a proxied object
            if (prop === _shared_constants__WEBPACK_IMPORTED_MODULE_5__["ORIGINAL"])
                return target;
            const result = Reflect.get(target, prop);
            if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].proxyIsMuted || _shared_utils__WEBPACK_IMPORTED_MODULE_3__["isInternal"](prop))
                return result;
            // Mutating array methods make a lot of noise, so we wrap them in a proxy
            // Only one update will be fired - for the actual array.
            if (_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isArrayMutation"](target, prop)) {
                const handler = {
                    apply(func, applyTarget, args) {
                        return _shared_pubSub__WEBPACK_IMPORTED_MODULE_0__["dispatchUpdateInNextStore"]({
                            target: applyTarget,
                            notifyTarget: true,
                            value: args,
                            updater: (finalTarget, proxiedArgs) => {
                                Object(_shared_debug__WEBPACK_IMPORTED_MODULE_1__["logSet"])(target, prop, proxiedArgs);
                                const updateResult = Reflect.apply(
                                // @ts-ignore - Yes, symbol CAN be used as an index type
                                finalTarget[prop], finalTarget, proxiedArgs);
                                const rootPath = _shared_paths__WEBPACK_IMPORTED_MODULE_4__["get"](target);
                                // At this point, the array is updated. But the paths of the
                                // items could be wrong, so we refresh them.
                                _shared_utils__WEBPACK_IMPORTED_MODULE_3__["updateDeep"](finalTarget, (item, path) => {
                                    if (_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isTarget"](item)) {
                                        _shared_paths__WEBPACK_IMPORTED_MODULE_4__["addProp"](item, [...rootPath, ...path]);
                                    }
                                });
                                return updateResult;
                            },
                        });
                    },
                };
                return new Proxy(result, handler);
            }
            // For all other methods (.join, .toString(), etc) return the function
            // @ts-ignore - wrong, symbol can be used an an index type
            if (_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isFunction"](target[prop]))
                return result;
            // When we're outside the render cycle, we route
            // requests to the 'next version'
            // Note, this will result in another get(), but on the equivalent
            // target from the next store. muteProxy will be set so this line
            // isn't triggered in an infinite loop
            if (!_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].currentComponent) {
                const nextVersion = _shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].nextVersionMap.get(target);
                if (nextVersion)
                    return Reflect.get(nextVersion, prop);
            }
            // We record a get if a component is rendering, with the exception
            // of reading array length. This would be redundant, since changes to
            // length trigger a change on the array itself
            if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].currentComponent &&
                !(_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isArray"](target) && prop === "length" /* Length */)) {
                Object(_shared_debug__WEBPACK_IMPORTED_MODULE_1__["logGet"])(target, prop, result);
                addListener(_shared_paths__WEBPACK_IMPORTED_MODULE_4__["extend"](target, prop));
            }
            return result;
        },
        has(target, prop) {
            if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].proxyIsMuted)
                return Reflect.has(target, prop);
            // Arrays use `has` too, but we capture a listener elsewhere for that.
            // Here we only want to capture access to objects
            if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].currentComponent && !_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isArray"](target)) {
                Object(_shared_debug__WEBPACK_IMPORTED_MODULE_1__["logGet"])(target, prop);
                addListener(_shared_paths__WEBPACK_IMPORTED_MODULE_4__["extend"](target, prop));
            }
            const nextVersion = _shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].nextVersionMap.get(target);
            if (nextVersion)
                return Reflect.has(nextVersion, prop);
            return Reflect.has(target, prop);
        },
        ownKeys(target) {
            if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].proxyIsMuted)
                return Reflect.ownKeys(target);
            const nextVersion = _shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].nextVersionMap.get(target);
            if (nextVersion)
                return Reflect.ownKeys(nextVersion);
            if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].currentComponent) {
                Object(_shared_debug__WEBPACK_IMPORTED_MODULE_1__["logGet"])(target);
                addListener(_shared_paths__WEBPACK_IMPORTED_MODULE_4__["get"](target));
            }
            return Reflect.ownKeys(target);
        },
        set(target, prop, value) {
            if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].proxyIsMuted)
                return Reflect.set(target, prop, value);
            if (true) {
                if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].currentComponent) {
                    console.error([
                        `You are attempting to modify the store during a render cycle. `,
                        `(You're setting "${prop.toString()}" to "${value}" somewhere)\n`,
                        `This could result in subtle bugs. `,
                        `If you're changing the store in componentDidMount, wrap your `,
                        `code in a setTimeout() to allow the render cycle to complete `,
                        `before changing the store.`,
                    ].join(''));
                }
            }
            // If there's no change, we return
            // @ts-ignore - target[prop] is fine
            if (target[prop] === value)
                return true;
            return _shared_pubSub__WEBPACK_IMPORTED_MODULE_0__["dispatchUpdateInNextStore"]({
                target,
                prop,
                value,
                updater: (finalTarget, newValueProxy) => {
                    Object(_shared_debug__WEBPACK_IMPORTED_MODULE_1__["logSet"])(target, prop, newValueProxy);
                    return Reflect.set(finalTarget, prop, newValueProxy);
                },
            });
        },
        deleteProperty(target, prop) {
            if (_shared_state__WEBPACK_IMPORTED_MODULE_2__["default"].proxyIsMuted)
                return Reflect.deleteProperty(target, prop);
            return _shared_pubSub__WEBPACK_IMPORTED_MODULE_0__["dispatchUpdateInNextStore"]({
                target,
                prop,
                notifyTarget: true,
                updater: (finalTarget) => {
                    Object(_shared_debug__WEBPACK_IMPORTED_MODULE_1__["logDelete"])(target, prop);
                    return Reflect.deleteProperty(finalTarget, prop);
                },
            });
        },
    };
};
/**
 * Wrap an item in a proxy
 */
const createShallow = (target) => {
    if (true) {
        if (!target)
            throw Error('There is no target');
    }
    return new Proxy(target, getHandlerForObject(target));
};


/***/ }),

/***/ "./src/shared/constants.ts":
/*!*********************************!*\
  !*** ./src/shared/constants.ts ***!
  \*********************************/
/*! exports provided: PROP_PATH_SEP, PATH, ORIGINAL */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PROP_PATH_SEP", function() { return PROP_PATH_SEP; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PATH", function() { return PATH; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ORIGINAL", function() { return ORIGINAL; });
/**
 * To convert the path array to a string for the listener keys
 * Use a crazy separator. If the separator was a '.', and the user had a prop with a dot in it,
 * then it could cause false matches in the updated logic.
 */
const PROP_PATH_SEP = '~~~';
const PATH = Symbol('PATH');
const ORIGINAL = Symbol('ORIGINAL');


/***/ }),

/***/ "./src/shared/debug.ts":
/*!*****************************!*\
  !*** ./src/shared/debug.ts ***!
  \*****************************/
/*! exports provided: debugOn, debugOff, debug, logGet, logSet, logDelete, logUpdate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "debugOn", function() { return debugOn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "debugOff", function() { return debugOff; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "debug", function() { return debug; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logGet", function() { return logGet; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logSet", function() { return logSet; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logDelete", function() { return logDelete; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logUpdate", function() { return logUpdate; });
/* harmony import */ var _paths__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./paths */ "./src/shared/paths.ts");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./utils */ "./src/shared/utils.ts");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./state */ "./src/shared/state.ts");



const DEBUG_ON = 'on';
const DEBUG_OFF = 'off';
const hasLocalStorage = typeof window !== 'undefined' && !!window.localStorage;
let DEBUG = hasLocalStorage
    ? window.localStorage.RECOLLECT__DEBUG || DEBUG_OFF
    : DEBUG_OFF;
if (DEBUG === DEBUG_ON) {
    console.info('Recollect debugging is enabled. Type __RR__.debugOff() to turn it off.');
}
const debugOn = () => {
    DEBUG = DEBUG_ON;
    if (hasLocalStorage)
        window.localStorage.RECOLLECT__DEBUG = DEBUG;
};
const debugOff = () => {
    DEBUG = DEBUG_OFF;
    if (hasLocalStorage)
        window.localStorage.RECOLLECT__DEBUG = DEBUG;
};
const debug = (cb) => {
    if (DEBUG === DEBUG_ON)
        cb();
};
const logGet = (target, prop, value) => {
    debug(() => {
        console.groupCollapsed(`GET: ${_paths__WEBPACK_IMPORTED_MODULE_0__["extendToUserString"](target, prop)}`);
        console.info(`Component: <${_state__WEBPACK_IMPORTED_MODULE_2__["default"].currentComponent._name}>`);
        if (typeof value !== 'undefined') {
            console.info('Value:', value);
        }
        console.groupEnd();
    });
};
const logSet = (target, prop, value) => {
    debug(() => {
        console.groupCollapsed(`SET: ${_paths__WEBPACK_IMPORTED_MODULE_0__["extendToUserString"](target, prop)}`);
        console.info('From:', _utils__WEBPACK_IMPORTED_MODULE_1__["getValue"](target, prop));
        console.info('To:  ', value);
        console.groupEnd();
    });
};
const logDelete = (target, prop) => {
    debug(() => {
        console.groupCollapsed(`DELETE: ${_paths__WEBPACK_IMPORTED_MODULE_0__["extendToUserString"](target, prop)}`);
        console.info('Property: ', _paths__WEBPACK_IMPORTED_MODULE_0__["extendToUserString"](target, prop));
        console.groupEnd();
    });
};
const logUpdate = (component, propsUpdated) => {
    debug(() => {
        console.groupCollapsed(`UPDATE:  <${component._name}>`);
        console.info('Changed properties:', propsUpdated);
        console.groupEnd();
    });
};


/***/ }),

/***/ "./src/shared/paths.ts":
/*!*****************************!*\
  !*** ./src/shared/paths.ts ***!
  \*****************************/
/*! exports provided: makeUserString, makeInternalString, extend, extendToUserString, addProp, get, has, set */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "makeUserString", function() { return makeUserString; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "makeInternalString", function() { return makeInternalString; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "extend", function() { return extend; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "extendToUserString", function() { return extendToUserString; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addProp", function() { return addProp; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "get", function() { return get; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "has", function() { return has; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "set", function() { return set; });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./constants */ "./src/shared/constants.ts");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./utils */ "./src/shared/utils.ts");


// Joins an array that potentially contains symbols, which need an explicit
// 'toString()'
const join = (arr, joiner) => arr.map((item) => item.toString()).join(joiner);
/**
 * Convert a target and a prop into a user-friendly string like store.tasks.1.done
 */
const makeUserString = (propPath) => join(propPath, '.');
const makeInternalString = (propPath) => join(propPath, _constants__WEBPACK_IMPORTED_MODULE_0__["PROP_PATH_SEP"]);
/**
 * Takes the path stored in an object, and a new prop, and returns the two
 * combined
 */
const extend = (target, prop) => {
    const basePath = target[_constants__WEBPACK_IMPORTED_MODULE_0__["PATH"]] || [];
    if (typeof prop === 'undefined')
        return basePath;
    return basePath.concat(prop);
};
/**
 * Convert a target and a prop into a user-friendly string like store.tasks.1.done
 */
const extendToUserString = (target, prop) => makeUserString(extend(target, prop));
const addProp = (target, propPath) => {
    if (!target)
        return;
    Object.defineProperty(target, _constants__WEBPACK_IMPORTED_MODULE_0__["PATH"], {
        value: propPath,
        writable: true,
    });
};
const get = (target) => target[_constants__WEBPACK_IMPORTED_MODULE_0__["PATH"]] || [];
const has = (target) => _utils__WEBPACK_IMPORTED_MODULE_1__["isObject"](target) && _constants__WEBPACK_IMPORTED_MODULE_0__["PATH"] in target;
const set = (mutableTarget, propPath) => {
    mutableTarget[_constants__WEBPACK_IMPORTED_MODULE_0__["PATH"]] = propPath;
};


/***/ }),

/***/ "./src/shared/pubSub.ts":
/*!******************************!*\
  !*** ./src/shared/pubSub.ts ***!
  \******************************/
/*! exports provided: onUpdateInNextStore, dispatchUpdateInNextStore, afterChange */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "onUpdateInNextStore", function() { return onUpdateInNextStore; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "dispatchUpdateInNextStore", function() { return dispatchUpdateInNextStore; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "afterChange", function() { return afterChange; });
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./state */ "./src/shared/state.ts");

const subscribers = {};
const onUpdateInNextStore = (func) => {
    subscribers["UpdateNextStore" /* UpdateNextStore */] = func;
};
const dispatchUpdateInNextStore = (data) => {
    return subscribers["UpdateNextStore" /* UpdateNextStore */](data);
};
/**
 * Add a callback to be called every time the store changes
 */
const afterChange = (cb) => {
    _state__WEBPACK_IMPORTED_MODULE_0__["default"].manualListeners.push(cb);
};


/***/ }),

/***/ "./src/shared/state.ts":
/*!*****************************!*\
  !*** ./src/shared/state.ts ***!
  \*****************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/**
 * Any state shared between modules goes here
 * For internal use, not for consumers
 */
const state = {
    currentComponent: null,
    isBatchUpdating: false,
    isInBrowser: typeof window !== 'undefined',
    listeners: new Map(),
    manualListeners: [],
    nextVersionMap: new WeakMap(),
    proxyIsMuted: false,
    store: {},
};
/* harmony default export */ __webpack_exports__["default"] = (state);


/***/ }),

/***/ "./src/shared/utils.ts":
/*!*****************************!*\
  !*** ./src/shared/utils.ts ***!
  \*****************************/
/*! exports provided: isObject, isArray, isMap, isSet, isTarget, isInternal, isFunction, isArrayMutation, clone, getValue, setValue, getSize, replaceObject, updateDeep, whileMuted, useProps */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isObject", function() { return isObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isArray", function() { return isArray; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isMap", function() { return isMap; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isSet", function() { return isSet; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isTarget", function() { return isTarget; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isInternal", function() { return isInternal; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isFunction", function() { return isFunction; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isArrayMutation", function() { return isArrayMutation; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "clone", function() { return clone; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getValue", function() { return getValue; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "setValue", function() { return setValue; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getSize", function() { return getSize; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "replaceObject", function() { return replaceObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "updateDeep", function() { return updateDeep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "whileMuted", function() { return whileMuted; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "useProps", function() { return useProps; });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./constants */ "./src/shared/constants.ts");
/* harmony import */ var _state__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./state */ "./src/shared/state.ts");


// 'object' meaning 'plain object'.
const isObject = (item) => !!item && typeof item === 'object' && item.constructor === Object;
const isArray = (item) => Array.isArray(item);
const isMap = (item) => item instanceof Map;
const isSet = (item) => item instanceof Set;
// A target is one of the four types that Recollect will proxy
const isTarget = (item) => isObject(item) || isArray(item) || isMap(item) || isSet(item);
// This is internal to JS or to Recollect
const isInternal = (prop) => [_constants__WEBPACK_IMPORTED_MODULE_0__["PATH"], 'constructor', 'toJSON'].includes(prop);
const isFunction = (item) => typeof item === 'function';
const isArrayMutation = (target, prop) => isArray(target) &&
    [
        "copyWithin" /* CopyWithin */,
        "fill" /* Fill */,
        "pop" /* Pop */,
        "push" /* Push */,
        "reverse" /* Reverse */,
        "shift" /* Shift */,
        "sort" /* Sort */,
        "splice" /* Splice */,
        "unshift" /* Unshift */,
    ].includes(prop);
const clone = (target) => {
    if (isObject(target))
        return Object.assign({}, target);
    // @ts-ignore
    if (isArray(target))
        return target.slice();
    // @ts-ignore
    if (isMap(target))
        return new Map(target);
    // @ts-ignore
    if (isSet(target))
        return new Set(target);
    return target;
};
/**
 * Get the value from an object. This is for end-user objects. E.g. not
 * accessing a symbol property on a Map object.
 */
const getValue = (target, prop) => {
    if (isMap(target))
        return target.get(prop);
    if (isSet(target))
        return prop;
    if (isArray(target))
        return target[prop];
    return target[prop];
};
const setValue = (mutableTarget, prop, value) => {
    if (isObject(mutableTarget)) {
        mutableTarget[prop] = value;
    }
    else if (isArray(mutableTarget)) {
        // @ts-ignore - is fine, prop can be a symbol
        mutableTarget[prop] = value;
    }
    else if (isMap(mutableTarget)) {
        // @ts-ignore
        mutableTarget.set(prop, value);
    }
    else if (isSet(mutableTarget)) {
        // @ts-ignore
        mutableTarget.add(value);
    }
    else {
        throw Error('Unexpected type');
    }
};
const getSize = (item) => {
    if (isObject(item))
        return Object.keys(item).length;
    // @ts-ignore - TS thinks item is never
    if (isArray(item))
        return item.length;
    // @ts-ignore - TS thinks item is never
    if (isMap(item) || isSet(item))
        return item.size;
    throw Error('Unexpected type');
};
/**
 * Shallow replaces the contents of one object with the contents of another.
 * The top level object will remain the same, but all changed content will
 * be replaced with the new content.
 */
const replaceObject = (mutableTarget, nextObject) => {
    if (nextObject) {
        // From the new data, add to the old data anything that's new
        // (from the top level props only)
        Object.entries(nextObject).forEach(([prop, value]) => {
            if (mutableTarget[prop] !== value) {
                mutableTarget[prop] = value;
            }
        });
        // Clear out any keys that aren't in the new data
        Object.keys(mutableTarget).forEach((prop) => {
            if (!(prop in nextObject)) {
                delete mutableTarget[prop];
            }
        });
    }
    else {
        // Just empty the old object
        Object.keys(mutableTarget).forEach((prop) => {
            delete mutableTarget[prop];
        });
    }
};
/**
 * Traverse a tree, calling a callback for each node with the item and the path.
 * This can either mutate each value, or return a new value to create a clone.
 * @example const clone = utils.updateDeep(original, utils.clone);
 * Only traverses the targets supported by Recollect.
 */
const updateDeep = (mutableTarget, updater) => {
    const path = [];
    const processLevel = (target) => {
        const updated = updater(target, path.slice());
        // If the updater returns something, use it. Else mutate the original.
        const next = typeof updated !== 'undefined' ? updated : target;
        const handleEntry = (prop, value) => {
            path.push(prop);
            const processed = processLevel(value);
            path.pop();
            setValue(next, prop, processed);
        };
        if (isObject(next)) {
            Object.entries(next).forEach(([prop, value]) => {
                handleEntry(prop, value);
            });
        }
        else if (isArray(next) || isMap(next)) {
            next.forEach((value, prop) => {
                handleEntry(prop, value);
            });
        }
        else if (isSet(next)) {
            // A set is special - you can't reassign what's in a particular
            // 'position' like the other three, so we do some fancy footwork...
            const setContents = Array.from(next);
            next.clear();
            setContents.forEach((value) => {
                handleEntry(value, value);
            });
        }
        return next;
    };
    return processLevel(mutableTarget);
};
/**
 * Does some work while the proxy is muted. Returns the result of the
 * callback as a convenience.
 * DO NOT expose this to users as it encourages non-deterministic behaviour.
 */
const whileMuted = (cb) => {
    _state__WEBPACK_IMPORTED_MODULE_1__["default"].proxyIsMuted = true;
    const result = cb();
    _state__WEBPACK_IMPORTED_MODULE_1__["default"].proxyIsMuted = false;
    return result;
};
/**
 * This is a convenience method that triggers a read on each item in the array.
 * When used during the render cycle of a collected component, it has the
 * side-effect of subscribing that component to each item in the array.
 */
const useProps = (props) => {
    // useProps must never return, so it can be used in the body of a component
    props.includes(0);
};


/***/ }),

/***/ "./src/store.ts":
/*!**********************!*\
  !*** ./src/store.ts ***!
  \**********************/
/*! exports provided: updateStore, initStore, batch */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "updateStore", function() { return updateStore; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "initStore", function() { return initStore; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batch", function() { return batch; });
/* harmony import */ var _proxyManager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./proxyManager */ "./src/proxyManager.ts");
/* harmony import */ var _shared_pubSub__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./shared/pubSub */ "./src/shared/pubSub.ts");
/* harmony import */ var _updateManager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./updateManager */ "./src/updateManager.ts");
/* harmony import */ var _shared_utils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./shared/utils */ "./src/shared/utils.ts");
/* harmony import */ var _shared_paths__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./shared/paths */ "./src/shared/paths.ts");
/* harmony import */ var _shared_state__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./shared/state */ "./src/shared/state.ts");
/* harmony import */ var _shared_constants__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./shared/constants */ "./src/shared/constants.ts");







/**
 * This is the store, as exported to the user. When the store is passed to a
 * component, it is shallow cloned. This leaves us free to mutate the root
 * level directly.
 */
_shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].store = _proxyManager__WEBPACK_IMPORTED_MODULE_0__["createShallow"]({});
/**
 * Deep update the store, the following rules are followed:
 * - If updating the root level, the store object itself is mutated.
 * - For any other (deep) update we clone each node along the path to
 *   the target to update (the target is cloned too).
 */
const updateStore = ({ target, prop, value, notifyTarget = false, updater, }) => _shared_utils__WEBPACK_IMPORTED_MODULE_3__["whileMuted"](() => {
    let result;
    // This function doesn't know anything about the prop being set.
    // It just finds the target (the parent of the prop) and
    // calls updater() with it.
    const targetPath = _shared_paths__WEBPACK_IMPORTED_MODULE_4__["get"](target);
    // Note that if this update is a method (e.g. arr.push()) then prop can be
    // undefined, meaning the prop path won't be extended, and will just be
    // the path of the target (the array) which is correct.
    const propPath = _shared_paths__WEBPACK_IMPORTED_MODULE_4__["extend"](target, prop);
    // If we change the length/size of an array/map/set, we will want to
    // trigger a render of the parent path.
    let targetChangedSize = false;
    const initialSize = _shared_utils__WEBPACK_IMPORTED_MODULE_3__["getSize"](target);
    let newValue = value;
    // Make sure the new value is deeply wrapped in proxies, if it's a target
    if (_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isTarget"](newValue)) {
        newValue = _shared_utils__WEBPACK_IMPORTED_MODULE_3__["updateDeep"](value, (item, thisPropPath) => {
            if (!_shared_utils__WEBPACK_IMPORTED_MODULE_3__["isTarget"](item))
                return item;
            const next = _shared_utils__WEBPACK_IMPORTED_MODULE_3__["clone"](item);
            _shared_paths__WEBPACK_IMPORTED_MODULE_4__["addProp"](next, [...propPath, ...thisPropPath]);
            return _proxyManager__WEBPACK_IMPORTED_MODULE_0__["createShallow"](next);
        });
    }
    if (!targetPath.length) {
        // If the target is the store root, it's mutated in place.
        result = updater(_shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].store, newValue);
        targetChangedSize = _shared_utils__WEBPACK_IMPORTED_MODULE_3__["getSize"](_shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].store) !== initialSize;
    }
    else {
        targetPath.reduce((item, thisProp, i) => {
            const thisValue = _shared_utils__WEBPACK_IMPORTED_MODULE_3__["getValue"](item, thisProp);
            // Shallow clone this level
            let clone = _shared_utils__WEBPACK_IMPORTED_MODULE_3__["clone"](thisValue);
            _shared_paths__WEBPACK_IMPORTED_MODULE_4__["addProp"](clone, _shared_paths__WEBPACK_IMPORTED_MODULE_4__["get"](thisValue));
            // Wrap the clone in a proxy
            clone = _proxyManager__WEBPACK_IMPORTED_MODULE_0__["createShallow"](clone);
            // Mutate this level (swap out the original for the clone)
            _shared_utils__WEBPACK_IMPORTED_MODULE_3__["setValue"](item, thisProp, clone);
            // If we're at the end of the path, then 'clone' is our target
            if (i === targetPath.length - 1) {
                result = updater(clone, newValue);
                targetChangedSize = _shared_utils__WEBPACK_IMPORTED_MODULE_3__["getSize"](clone) !== initialSize;
                // We keep a reference between the original target and the clone
                // `target` may or may not be wrapped in a proxy (Maps and Sets are)
                // So we check/get the unproxied version
                _shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].nextVersionMap.set(target[_shared_constants__WEBPACK_IMPORTED_MODULE_6__["ORIGINAL"]] || target, clone);
            }
            return clone;
        }, _shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].store);
    }
    // If the 'size' of a target changes, it's reasonable to assume that
    // users of the target are going to need to re-render, else use the prop
    const notifyPath = notifyTarget || targetChangedSize ? targetPath : propPath;
    _updateManager__WEBPACK_IMPORTED_MODULE_2__["notifyByPath"](notifyPath);
    return result;
});
_shared_pubSub__WEBPACK_IMPORTED_MODULE_1__["onUpdateInNextStore"](updateStore);
/**
 * Empty the Recollect store and replace it with new data.
 */
const initStore = (data) => {
    _shared_utils__WEBPACK_IMPORTED_MODULE_3__["replaceObject"](_shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].store, data);
};
/**
 * Executes the provided function, then updates appropriate components and calls
 * listeners registered with `afterChange()`. Guaranteed to only trigger one
 * update. The provided function must only contain synchronous code.
 */
const batch = (cb) => {
    _shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].isBatchUpdating = true;
    cb();
    _shared_state__WEBPACK_IMPORTED_MODULE_5__["default"].isBatchUpdating = false;
    _updateManager__WEBPACK_IMPORTED_MODULE_2__["flushUpdates"]();
};


/***/ }),

/***/ "./src/updateManager.ts":
/*!******************************!*\
  !*** ./src/updateManager.ts ***!
  \******************************/
/*! exports provided: flushUpdates, notifyByPath, removeListenersForComponent */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "flushUpdates", function() { return flushUpdates; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "notifyByPath", function() { return notifyByPath; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "removeListenersForComponent", function() { return removeListenersForComponent; });
/* harmony import */ var _shared_debug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./shared/debug */ "./src/shared/debug.ts");
/* harmony import */ var _shared_state__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./shared/state */ "./src/shared/state.ts");
/* harmony import */ var _shared_paths__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./shared/paths */ "./src/shared/paths.ts");



const queue = {
    components: new Map(),
    changedPaths: new Set(),
};
const flushUpdates = () => {
    queue.components.forEach((propsUpdated, component) => {
        Object(_shared_debug__WEBPACK_IMPORTED_MODULE_0__["logUpdate"])(component, Array.from(propsUpdated));
        component.update();
    });
    _shared_state__WEBPACK_IMPORTED_MODULE_1__["default"].manualListeners.forEach((cb) => cb({
        changedProps: Array.from(queue.changedPaths),
        renderedComponents: Array.from(queue.components.keys()),
        store: _shared_state__WEBPACK_IMPORTED_MODULE_1__["default"].store,
    }));
    queue.components.clear();
    queue.changedPaths.clear();
};
/**
 * Updates any component listening to:
 * - the exact propPath that has been changed. E.g. `tasks.2`
 * - a path further up the object tree. E.g. a component listening
 *   on `tasks.0` need to know if `tasks = 'foo'` happens
 * And if the path being notified is the top level (an empty path), everyone
 * gets updated.
 */
const notifyByPath = (propPath) => {
    const pathString = _shared_paths__WEBPACK_IMPORTED_MODULE_2__["makeInternalString"](propPath);
    const userFriendlyPropPath = _shared_paths__WEBPACK_IMPORTED_MODULE_2__["makeUserString"](propPath);
    queue.changedPaths.add(userFriendlyPropPath);
    _shared_state__WEBPACK_IMPORTED_MODULE_1__["default"].listeners.forEach((components, listenerPath) => {
        if (pathString === '' || // Notify everyone for top-level changes
            pathString === listenerPath) {
            components.forEach((component) => {
                const propsUpdated = queue.components.get(component) || new Set();
                propsUpdated.add(userFriendlyPropPath);
                queue.components.set(component, propsUpdated);
            });
        }
    });
    // If we're not batch updating, flush the changes now, otherwise this
    // will be called when the batch is complete
    if (!_shared_state__WEBPACK_IMPORTED_MODULE_1__["default"].isBatchUpdating)
        flushUpdates();
};
const removeListenersForComponent = (componentToRemove) => {
    _shared_state__WEBPACK_IMPORTED_MODULE_1__["default"].listeners.forEach((components, listenerPath) => {
        const filteredComponents = Array.from(components).filter((existingComponent) => existingComponent !== componentToRemove);
        if (filteredComponents.length) {
            _shared_state__WEBPACK_IMPORTED_MODULE_1__["default"].listeners.set(listenerPath, new Set(filteredComponents));
        }
        else {
            // If there are no components left listening, remove the path
            // For example, leaving a page will unmount a bunch of components
            _shared_state__WEBPACK_IMPORTED_MODULE_1__["default"].listeners.delete(listenerPath);
        }
    });
};


/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "react" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_react__;

/***/ })

/******/ });
});
//# sourceMappingURL=index.js.map